
Smart Proxy - Feature #3034

TFTP file download should be synchronous and handle errors

09/06/2013 07:48 AM - Dominic Cleal

Status: New   

Priority: Normal   

Assignee:    

Category: TFTP   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged: Yes Found in Releases:  

Bugzilla link: 1572592 Red Hat JIRA:  

Pull request:    

Description

The TFTP file download feature currently spawns wget in the background, so offers no tracking of progress or download errors.

It should perform downloads as a synchronous operation, which will allow us to report success or failure back to Foreman when

provisioning hosts.  Async downloads also mean that Foreman often boots VMs up too quickly, before the boot files have

downloaded.

wget has another issue under failure, as it leaves a zero byte file in place which means we think downloads were a success.

Given the proxy's usually deployed on WEBrick, a synchronous download could tie up its resources, making it inaccessible to others

though.

Related issues:

Related to Foreman - Refactor #5121: Download kernel and image during OS crea... New 04/09/2014

Related to Smart Proxy - Bug #6289:  vmlinuz/initrd files corrupted during wh... Closed 06/19/2014

Related to Smart Proxy - Bug #16674: when downloading boot images, a failure ... Duplicate 09/23/2016

Related to Smart Proxy - Bug #5069: TFTP automatic boot file download does no... New 04/03/2014

Related to Foreman - Feature #19389: Change TFTP filename pattern to include ... Closed

Has duplicate Smart Proxy - Bug #11067: Failing TFTP fetch filed doesn't trig... Duplicate 07/09/2015

Has duplicate Foreman - Bug #16609: race condition when using pxe icw virtual... Duplicate 09/20/2016

History

#1 - 04/09/2014 11:06 AM - Dominic Cleal

- Related to Refactor #5121: Download kernel and image during OS creation rather than prior build added

#2 - 06/17/2014 02:11 PM - Dominic Cleal

- Bugzilla link set to https://bugzilla.redhat.com/show_bug.cgi?id=1110378

edit: moved to #6289

#3 - 06/19/2014 02:29 PM - Dominic Cleal

- Related to Bug #6289:  vmlinuz/initrd files corrupted during when multiple hosts created simultaneously added

#4 - 06/19/2014 02:30 PM - Dominic Cleal

- Bugzilla link deleted (https://bugzilla.redhat.com/show_bug.cgi?id=1110378)

#5 - 10/06/2014 06:06 AM - Lukas Zapletal

For the record, RHOSP team hit this. We might want to speak about bumping up the priority of this.

#6 - 04/29/2015 03:19 AM - Ohad Levy

- Bugzilla link set to 1215588
#7 - 07/09/2015 08:42 AM - Dominic Cleal

- Has duplicate Bug #11067: Failing TFTP fetch filed doesn't trigger error in UI added

#8 - 09/20/2016 06:07 AM - Dominic Cleal

- Has duplicate Bug #16609: race condition when using pxe icw virtual HW and a new OS added

#9 - 09/21/2016 10:03 AM - Anonymous

- Status changed from New to Assigned

- Assignee set to Anonymous

#10 - 09/23/2016 12:27 PM - Anonymous

- Related to Bug #16674: when downloading boot images, a failure does not fail the operation in the UI added

#11 - 10/20/2016 03:01 AM - Lukas Zapletal

When touching this code, consider downloading the files under different (temporary) names so we shorten the window when different host (not the

one being blocked by the download) sees incorrect file (e.g. during upgrading to newer version).

Also I would like to keep the current (asynchronous) behavior in some way so it can be used when we implement #5121

I am currently working on an issue when file was downloaded incorrectly (error during transmission) and wget is not able to fix this anymore since it

only compares timestamps. If you can take this into consideration when designing the new way of downloading.

#12 - 11/04/2016 01:30 PM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/smart-proxy/pull/472 added

#13 - 11/09/2016 06:53 AM - Ivan Necas

- Target version set to 1.3.2

#14 - 12/30/2016 09:46 AM - Anonymous

- Related to Bug #5069: TFTP automatic boot file download does not track updates added

#15 - 10/09/2017 10:41 AM - Lukas Zapletal

- Related to Feature #19389: Change TFTP filename pattern to include unique installation media ID added

#16 - 04/27/2018 12:20 PM - Lukas Zapletal

- Bugzilla link changed from 1215588 to 1572592

- Pull request deleted (https://github.com/theforeman/smart-proxy/pull/472)

#17 - 10/15/2018 11:41 AM - Tomer Brisker

- Target version deleted (677)

#18 - 01/29/2019 02:43 PM - Lukas Zapletal

- Status changed from Ready For Testing to New

- Triaged set to Yes

- Assignee deleted (Anonymous)
